* Descriptive statistics to understand differences in ART regimes;
* Results presented in 'Treatment Strategy' subsection in section 'Stage 3';


libname start 'U:\data';
data art;
set start.art (where=(art=1));
rename recorddt=ART_SD;
run;

proc sort data=art;
by id ART_SD;
run;

data first_art;
set art;
by id;
if first.id;
length first_art $ 5;
if nnrti=1 then first_art="NNRTI";
if pi=1 then first_art="PI";
if insti=1 then first_art="INSTI";
if nnrti=0 and pi=0 and insti=0 then first_art="OTHER";
run;

proc freq data=first_art;
table first_art;
run;
 data sara;
 set first_art;
 where missing(first_art)=1;
 run;

data cero;
set mylib.cero_hivc_aids_death_3_newvacs (keep=id month2 year_0 first_art_class haart_class everhaart);
where year_0>=2005 and year_0<=2013 and month2<=60 and everhaart=1;
by id;
if first.id; 
length first_art $ 5;
if haart_class='1' or first_art_class=2 then first_art="PI";
if haart_class='3' then first_art="NNRTI";
if haart_class='19.1' then first_art="INSTI";
if haart_class='4.1' or first_art_class='4.2'  then first_art="NRTI";
if haart_class not in ('1','2','3','4.1','4.2','19.1')  then first_art="OTHER";
run;

proc freq data=cero;
table haart_class first_art;
run;
