* This program computes the estimates in the first row of Table 2;


%include '/proj/START/programs/slodi/start_hivc/g_formula/start/gformula_rct/gformula_rct.sas' ;
libname main '/proj/START/data/slodi/hivc_start/start/gformula_rct';



options  nomlogic nosymbolgen nonotes;


 data sample;
		  set mylib.cero_start_aids_death;
		  where  id not in (125,511,732,1679,1874,2296,3564,4122,4655) and month2<60 ;
		  if _n_=1 then Pi=constant('pi');
		  retain Pi;
country_cat=0; cd4_0_new_cat=0; age_0_new_cat=0; rna_0_new_cat=0;
if country_new=1 or country_new=2 or country_new=6 then country_cat=1;
if cd4_0>650 then cd4_0_new_cat=1; 	
if age_0>35 then age_0_new_cat=1; 
if rna_0>5000 then rna_0_new_cat=1; 		
	mytime = (month2 * (0.001 ** (month2)))*10000 ;
	cos1radiant = cos (0.5*Pi*month2); 
	cos2radiant = cos (2*0.5*Pi*month2); 
	arm=rtreat-1;
	run;


	%macro my2mograce;

   if month2 = 2 then do;
                if everhaart = 0 then do;
        everhaart = 1 ;
        intervened = 1 ;
        everhaart_totinterv = everhaart - intervened + 1;
        totinterv = totinterv + 1;
        severhaart[month2] = 1 ;
        end;
    end;
	
%mend;


	%macro my6mograce;

   if month2 = 6 then do;
                if everhaart = 0 then do;
        everhaart = 1 ;
        intervened = 1 ;
        everhaart_totinterv = everhaart - intervened + 1;
        totinterv = totinterv + 1;
        severhaart[month2] = 1 ;
        end;
    end;
	
%mend;


%macro createmytime ;
   mytime = (month2 * (0.001 ** (month2)))*10000; 
	cos1radiant =  cos (0.5*3.14159265359*month2);
	cos2radiant =  cos (2*0.5*3.14159265359*month2);
%mend ;



%let interva1 = intno=1 ,  nintvar=1,
   intlabel='start within 2 months of randomization',
  intvar1=everhaart, inttype1=-1,   inttimes1= 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 , intusermacro1=my2mograce;


  
%macro cutgrace_noaids(intcut=,intgrace=) ;

               
                 
                tgrace = month2 - &intgrace ;
               array dyncond{0:%eval(&timepoints-1)};

					  if ( sqrtcd4 < sqrt(&intcut) AND visit_cd4=1  AND sqrtcd4_l1 < sqrt(&intcut))=1 then do;

                               
                                                dyncond[month2]  = 1;
                                        end;
                                        else do;
                                                dyncond[month2] = 0;
                                        end;
                                       if month2 > 0 and  dyncond[month2 - 1] = 1 then dyncond[month2] = 1;
                                        if dyncond[month2] = 0 and s&&intvar&i [month2] = 1 then do;
                                                &&intvar&i = 0;
                                                s&&intvar&i[month2] = 0 ;
                                                &&intvar&i.._totinterv = &&intvar&i.._totinterv + 1;
                                                intervened = 1;
                                                intervenedk[month2] = 1;
                                                totinterv = totinterv + 1;
                                        end;
                                      
                                        if month2 ge &intgrace then do;
                                                if dyncond[tgrace] = 1 and s&&intvar&i[ month2] = 0 then do;
                                                        &&intvar&i = 1;
                                                        s&&intvar&i[month2] = 1 ;
                                                        &&intvar&i.._totinterv = &&intvar&i.._totinterv + 1;
                                                        intervened = 1;
                                                        intervenedk[month2] = 1;
                                                        totinterv = totinterv + 1;
                                                end;


                                        end;


%mend;


%let intervb1 = intno=1 ,  nintvar=1,
  intlabel='start within 1 month of 2nd cd4<350', 
  intvar1=everhaart, inttype1=-1,   inttimes1= 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30
          31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 , intusermacro1=cutgrace_noaids(intcut=351,intgrace=2);
	


proc datasets library = work nolist ;
save sample ;
quit;


options nonotes nosymbolgen  ;

%let nsamples =500 ;
%let numint = ; 
%gformula_wrapper(
data= sample,
nsimul=100000, 
id=id,
time=month2,           
timeptype = conspl ,
 timeknots =  6  20 28 , 
timepoints=60,
timefuncgen = createmytime ,
outc=event,
censlost=censor,  
numint=  1  ,
outctype=binsurv,
arm = arm ,
/* bit of code to obtain the hazard ratio , added April 26th */
hazardratio = 1,
bootstrap_hazard = 1,/* or 0 if you don't need the bootstraps */
forrct = 1,


/* for first arm */

numinta=  1  ,
fixedcova=   sex  cd4_0_new_cat   country_cat  rna_0_new_cat  age_0_new_cat,
ncova=3,
cova1=lnrna, cova1otype=4, cova1ptype=lag1bin,   
cova1randomvisitp = visit_rna, cova1visitpmaxgap = 12 ,   cova1visitpcount = ts_rna ,cova1addvars =  cos1radiant cos2radiant  ,
cova2=sqrtcd4,     cova2otype=3, cova2ptype=lag1bin,  
cova2randomvisitp = visit_cd4,  cova2visitpcount = ts_cd4  ,  cova2visitpmaxgap = 12,   cova2addvars = cos1radiant cos2radiant , 
cova3=everhaart, cova3otype=2, cova3ptype=tsswitch1, cova3addvars = mytime , 
refinta=1, 
runnca = 1 ,


/* for second arm */
numintb=  1  ,
fixedcovb=   sex  cd4_0_new_cat   country_cat  rna_0_new_cat  age_0_new_cat,
ncovb=3,
covb1=lnrna, covb1otype=4, covb1ptype=lag1bin,   
covb1randomvisitp = visit_rna, covb1visitpmaxgap = 12 , covb1visitpcount = ts_rna , covb1addvars =  cos1radiant cos2radiant  ,
covb2=sqrtcd4,     covb2otype=3, covb2ptype=lag1bin,  
covb2randomvisitp = visit_cd4,  covb2visitpcount = ts_cd4  ,  covb2visitpmaxgap = 12,   covb2addvars = cos1radiant cos2radiant , 
covb3=everhaart, covb3otype=2, covb3ptype=tsswitch1, covb3addvars = mytime , 
refintb=1, 
runncb = 1 ,
savelib = main ,
seed= 1, nsamples = &nsamples ,
check_cov_models = 1,
survdata = surv_start, 
observed_surv=obsurv_start, 
covmeandata=covmean_start, 
intervname = myinterv,
resultsdata = myresults,
print_stats=0,
usespline = 0 ,
printlogstats = 0 

);

 
 



