* This program creates the plots in WebFigure 2 and WebFigure 4;
libname main '/proj/START/data/slodi/hivc_start/hivc';

*INTERVENTION 1 in HIV-CAUSAL (immediate ART);
data simulated1;
set main.simuldata1;
keep slnrna1-slnrna60 ssqrtcd41-ssqrtcd460 severhaart1-severhaart60 ;
run;

data simulated1 (drop=slnrna1-slnrna60);
set simulated1;
array und{1:60} und1-und60;
array slnrna{1:60} slnrna1-slnrna60;
do i=1 to 60;
und{i}=0;
if slnrna{i}<log(51) then und{i}=1;
end;
run;

ods output quantiles=quantiles;
proc univariate  data=simulated1;
var _numeric_;
proc sort;
by varname;
run;
proc transpose data = quantiles out = quan_tran (drop=_name_ rename=(_75__Q3 = p75 _50__median = median _25__Q1 = p25));
  by varname;
  var estimate;
  id quantile;
  where quantile in: ('75', '50', '25');
run;

data simul1_cd4 (drop=varname);
set quan_tran;
where substr(varname,1,3)="ssq";
 month2=input(substr(varname, 9), 5.);
run;

proc sort data=simul1_cd4;
by month2;
run;


proc means  data=simulated1 noprint;
output out=means mean=;
run;

proc transpose data = means out = mean_tran ( rename=col1=mean );
run;

data simul1_prop_und (drop=_NAME_);
set mean_tran;
where substr(_NAME_,1,3)="und";
 month2=input(substr(_NAME_, 4), 5.);
run;
proc sort data=simul1_prop_und;
by month2;
run;

data simul1_prop_art (drop=_NAME_);
set mean_tran;
where substr(_NAME_,1,3)="sev";
 month2=input(substr(_NAME_, 11), 5.);
run;
proc sort data=simul1_prop_art;
by month2;
run;

proc datasets lib=work;
delete means mean_tran quantiles quan_tran simulated1;
quit;
run;

*INTERVENTION 2 in HIV-CAUSAL (deferred ART);

data simulated2;
set main.simuldata2;
keep slnrna1-slnrna60 ssqrtcd41-ssqrtcd460 severhaart1-severhaart60 ;
run;
data simulated2;
set main.simuldata2;
keep slnrna1-slnrna60 ssqrtcd41-ssqrtcd460 severhaart1-severhaart60 ;
run;

data simulated2 (drop=slnrna1-slnrna60);
set simulated2;
array und{1:60} und1-und60;
array slnrna{1:60} slnrna1-slnrna60;
do i=1 to 60;
und{i}=0;
if slnrna{i}<log(51) then und{i}=1;
end;
run;

ods output quantiles=quantiles;
proc univariate  data=simulated2;
var _numeric_;
proc sort;
by varname;
run;
proc transpose data = quantiles out = quan_tran (drop=_name_ rename=(_75__Q3 = p75 _50__median = median _25__Q1 = p25));
  by varname;
  var estimate;
  id quantile;
  where quantile in: ('75', '50', '25');
run;

data simul2_cd4 (drop=varname);
set quan_tran;
where substr(varname,1,3)="ssq";
 month2=input(substr(varname, 9), 5.);
run;

proc sort data=simul2_cd4;
by month2;
run;


proc means  data=simulated2 noprint;
output out=means mean=;
run;

proc transpose data = means out = mean_tran ( rename=col1=mean );
run;

data simul2_prop_und (drop=_NAME_);
set mean_tran;
where substr(_NAME_,1,3)="und";
 month2=input(substr(_NAME_, 4), 5.);
run;
proc sort data=simul2_prop_und;
by month2;
run;

data simul2_prop_art (drop=_NAME_);
set mean_tran;
where substr(_NAME_,1,3)="sev";
 month2=input(substr(_NAME_, 11), 5.);
run;
proc sort data=simul2_prop_art;
by month2;
run;

proc datasets lib=work;
delete means mean_tran quantiles quan_tran simulated2;
quit;
run;

* libname start 'U:\data\slodi\hivc_start\start';
 libname start '/proj/START/data/slodi/hivc_start/start';


*INTERVENTION 1 in START (immediate ART);
data simulated1;
set start.simuldata1_early;
keep slnrna1-slnrna60 ssqrtcd41-ssqrtcd460 severhaart1-severhaart60 ;
run;


data simulated1 (drop=slnrna1-slnrna60);
set simulated1;
array und{1:60} und1-und60;
array slnrna{1:60} slnrna1-slnrna60;
do i=1 to 60;
und{i}=0;
if slnrna{i}<log(51) then und{i}=1;
end;
run;

ods output quantiles=quantiles;
proc univariate  data=simulated1;
var _numeric_;
proc sort;
by varname;
run;
proc transpose data = quantiles out = quan_tran (drop=_name_ rename=(_75__Q3 = p75 _50__median = median _25__Q1 = p25));
  by varname;
  var estimate;
  id quantile;
  where quantile in: ('75', '50', '25');
run;

data simul1_cd4_start (drop=varname);
set quan_tran;
where substr(varname,1,3)="ssq";
 month2=input(substr(varname, 9), 5.);
run;

proc sort data=simul1_cd4_start;
by month2;
run;


proc means  data=simulated1 noprint;
output out=means mean=;
run;

proc transpose data = means out = mean_tran ( rename=col1=mean );
run;

data simul1_prop_und_start (drop=_NAME_);
set mean_tran;
where substr(_NAME_,1,3)="und";
 month2=input(substr(_NAME_, 4), 5.);
run;
proc sort data=simul1_prop_und_start;
by month2;
run;

data simul1_prop_art_start (drop=_NAME_);
set mean_tran;
where substr(_NAME_,1,3)="sev";
 month2=input(substr(_NAME_, 11), 5.);
run;
proc sort data=simul1_prop_art_start;
by month2;
run;

proc datasets lib=work;
delete means mean_tran quantiles quan_tran simulated1;
quit;
run;

*INTERVENTION 2 in START (deferred ART);

data simulated2;
set start.simuldata1_late;
keep slnrna1-slnrna60 ssqrtcd41-ssqrtcd460 severhaart1-severhaart60 ;
run;

data simulated2 (drop=slnrna1-slnrna60);
set simulated2;
array und{1:60} und1-und60;
array slnrna{1:60} slnrna1-slnrna60;
do i=1 to 60;
und{i}=0;
if slnrna{i}<log(51) then und{i}=1;
end;
run;

ods output quantiles=quantiles;
proc univariate  data=simulated2;
var _numeric_;
proc sort;
by varname;
run;
proc transpose data = quantiles out = quan_tran (drop=_name_ rename=(_75__Q3 = p75 _50__median = median _25__Q1 = p25));
  by varname;
  var estimate;
  id quantile;
  where quantile in: ('75', '50', '25');
run;

data simul2_cd4_start (drop=varname);
set quan_tran;
where substr(varname,1,3)="ssq";
 month2=input(substr(varname, 9), 5.);
run;

proc sort data=simul2_cd4_start;
by month2;
run;


proc means  data=simulated2 noprint;
output out=means mean=;
run;

proc transpose data = means out = mean_tran ( rename=col1=mean );
run;

data simul2_prop_und_start (drop=_NAME_);
set mean_tran;
where substr(_NAME_,1,3)="und";
 month2=input(substr(_NAME_, 4), 5.);
run;
proc sort data=simul2_prop_und_start;
by month2;
run;

data simul2_prop_art_start (drop=_NAME_);
set mean_tran;
where substr(_NAME_,1,3)="sev";
 month2=input(substr(_NAME_, 11), 5.);
run;
proc sort data=simul2_prop_art_start;
by month2;
run;

proc datasets lib=work;
delete means mean_tran quantiles quan_tran simulated2;
quit;
run;

* Merge the HIVC and START datasets;
data simul1_cd4_all;
merge simul1_cd4 simul1_cd4_start (rename=(p75=p75_start median=median_start p25=p25_start));
by month2;
p75=p75**2;
p25=p25**2;
median=median**2;
p75_start=p75_start**2;
p25_start=p25_start**2;
median_start=median_start**2;
run;

data simul2_cd4_all;
merge simul2_cd4 simul2_cd4_start (rename=(p75=p75_start median=median_start p25=p25_start));
by month2;
p75=p75**2;
p25=p25**2;
median=median**2;
p75_start=p75_start**2;
p25_start=p25_start**2;
median_start=median_start**2;
run;

data simul1_prop_art_all;
merge simul1_prop_art simul1_prop_art_start (rename=(mean=mean_start));
by month2;
run;
data simul2_prop_art_all;
merge simul2_prop_art simul2_prop_art_start (rename=(mean=mean_start));
by month2;
run;

data simul1_prop_und_all;
merge simul1_prop_und simul1_prop_und_start (rename=(mean=mean_start));
by month2;
run;
data simul2_prop_und_all;
merge simul2_prop_und simul2_prop_und_start (rename=(mean=mean_start));
by month2;
run;



options nonumber nodate;
ods pdf file="graph_hivc_start.pdf" startpage=no ;
legend1 value=(color=gray height=2 'Emulated trial') value=(color=black height=2 'Actual trial');
proc sgplot data=simul1_cd4_all noautolegend ;
title1 'Immediate treatment initiation';
series x=month2 y=median /     lineattrs = (thickness =2 pattern=1 color=gray) name="obs" legendlabel="Emulated trial";
series x=month2 y=p25 /   lineattrs = (thickness =2 pattern=2 color=gray);
series x=month2 y=p75 /   lineattrs = (thickness =2 pattern=2 color=gray);
series x=month2 y=median_start /     lineattrs = (thickness =2 pattern=1 color=black) name="rct" legendlabel="Actual trial";
series x=month2 y=p25_start /   lineattrs = (thickness =2 pattern=2 color=black);
series x=month2 y=p75_start /   lineattrs = (thickness =2 pattern=2 color=black);
xaxis label='Time since baseline, months' values = (0 10 20 30 40 50 60) /*labelattrs=(size=12)*/;
yaxis label='Median [IQR] CD4 count, cells/mm3'  values = (0 100 200 300 400 500 600 700 800 900 1000 1100 1200) /*labelattrs=(size=12)*/; 
keylegend "obs" "rct"/location=inside position=bottom across=1 noborder;
run;
proc sgplot data=simul2_cd4_all noautolegend;
title1 'Deferred treatment initiation';
series x=month2 y=median /     lineattrs = (thickness =2 pattern=1 color=gray) name="obs" legendlabel="Emulated trial";
series x=month2 y=p25 /   lineattrs = (thickness =2 pattern=2 color=gray);
series x=month2 y=p75 /   lineattrs = (thickness =2 pattern=2 color=gray);
series x=month2 y=median_start /     lineattrs = (thickness =2 pattern=1 color=black) name="rct" legendlabel="Actual trial";
series x=month2 y=p25_start /   lineattrs = (thickness =2 pattern=2 color=black);
series x=month2 y=p75_start /   lineattrs = (thickness =2 pattern=2 color=black);
xaxis label='Time since baseline, months' values = (0 10 20 30 40 50 60) labelattrs=(size=12);
yaxis label='Median IQR CD4 count, cells/mm3'  values = (0 100 200 300 400 500 600 700 800 900 1000 1100 1200) labelattrs=(size=12); 
keylegend "obs" "rct"/location=inside position=bottom across=1 noborder;
run;

proc sgplot data=simul1_prop_und_all noautolegend;
title1 ' Immediate treatment initiation';
where month2>2;
series x=month2 y=mean /     lineattrs = (thickness =2 pattern=1 color=gray)  name="obs" legendlabel="Emulated trial";
series x=month2 y=mean_start /     lineattrs = (thickness =2 pattern=1 color=black) name="rct" legendlabel="Actual trial" ;
xaxis label='Time since baseline, months' values = (0 10 20 30 40 50 60) labelattrs=(size=12) ;
yaxis label='Proportion with HIV-RNA<50 c/mL'   values = (0 0.2 0.4 0.6 0.8 1)  labelattrs=(size=12); 
keylegend "obs" "rct"/location=inside position=bottomright across=1 noborder;
run;

proc sgplot data=simul2_prop_und_all noautolegend;
title1 'Deferred treatment initiation';
where month2>2;
series x=month2 y=mean /     lineattrs = (thickness =2 pattern=1 color=gray)  name="obs" legendlabel="Emulated trial";
series x=month2 y=mean_start /     lineattrs = (thickness =2 pattern=1 color=black) name="rct" legendlabel="Actual trial";
xaxis label='Time since baseline, months' values = (0 10 20 30 40 50 60) labelattrs=(size=12) ;
yaxis label='Proportion with HIV-RNA<50 c/mL'   values = (0 0.2 0.4 0.6 0.8 1)  labelattrs=(size=12); 
keylegend "obs" "rct"/location=inside position=bottomright across=1 noborder;
run;

proc sgplot data=simul1_prop_art_all noautolegend;
title1 ' Immediate treatment initiation';
where month2>2;
series x=month2 y=mean /     lineattrs = (thickness =2 pattern=1 color=gray)  name="obs" legendlabel="Emulated trial";
series x=month2 y=mean_start /     lineattrs = (thickness =2 pattern=1 color=black) name="rct" legendlabel="Actual trial";
xaxis label='Time since baseline, months' values = (0 10 20 30 40 50 60) labelattrs=(size=12);
yaxis label='Proportion who had ever started treatment '   values = (0 0.2 0.4 0.6 0.8 1)  labelattrs=(size=12) ; 
keylegend "obs" "rct"/location=inside position=bottomright across=1 noborder;
run;

proc sgplot data=simul2_prop_art_all noautolegend;
title1 ' Deferred treatment initiation';
where month2>2;
series x=month2 y=mean /     lineattrs = (thickness =2 pattern=1 color=gray)  name="obs" legendlabel="Emulated trial";
series x=month2 y=mean_start /     lineattrs = (thickness =2 pattern=1 color=black) name="rct" legendlabel="Actual trial";
xaxis label='Time since baseline, months' values = (0 10 20 30 40 50 60) labelattrs=(size=12);
yaxis label='Proportion who had ever started treatment '   values = (0 0.2 0.4 0.6 0.8 1)  labelattrs=(size=12) ; 
keylegend "obs" "rct"/location=inside position=bottomright across=1 noborder;
run;

ods pdf close;

