
* This code produced the graphs in WebFigure 5;


*****************************************************************
* Graphs of simulated and observed survival curves and means;
*****************************************************************;
libname main '/proj/START/data/slodi/hivc_start/hivc';

*************************************************
***          START:  IMMEDIATE  *****************
*************************************************;

data surv;
set main.surv_hivc ;
where _sample_=0 and int=0;
keep risk:;
run;

data obs_surv;
set main.obsurv_hivc;
where _sample_=0;
keep obrisk: ;
run;

proc transpose data=surv out=surv_long;
run;
data surv_long;
set surv_long;
time + 1;
rename col1=surv;
run;

proc transpose data=obs_surv out=obs_surv_long;
run;

data obs_surv_long;
set obs_surv_long;
time + 1;
rename col1=obs_surv;
run;

data surv_new (drop=_NAME_);
merge surv_long obs_surv_long;
by time;
year=time/12;
surv=surv*100;
obs_surv=obs_surv*100;
run;

data obs_cov;
set main.covmean_hivc;
*(where=(_sample_=0));
year=month2/12;
everhaart=everhaart*100;
visit_rna=visit_rna*100;
visit_cd4=visit_cd4*100;
keep  year month2  visit_rna  visit_cd4  everhaart sqrtcd4 lnrna ;
run;

data sim_cov_visit_rna;
set main.myresults_hivc;
where int=0;
keep svisit_rna:;
run; 

proc transpose data=sim_cov_visit_rna out=visit_rna;
run;

data visit_rna;
  set visit_rna (rename=(col1=svisit_rna));
  year=(input(substr(_name_, 11), 5.)/12);
  svisit_rna=svisit_rna*100;
  drop _name_;
run; 


data sim_cov_visit_cd4;
set main.myresults_hivc;
where int=0;
keep svisit_cd4:;
run; 

proc transpose data=sim_cov_visit_cd4 out=visit_cd4;
run;

data visit_cd4;
  set visit_cd4 (rename=(col1=svisit_cd4));
  year=(input(substr(_name_, 11), 5.)/12);
  drop _name_;
  svisit_cd4= svisit_cd4*100;
run; 


data sim_cov_everhaart;
set main.myresults_hivc;
where int=0;
keep severhaart:;
run; 

proc transpose data=sim_cov_everhaart out=everhaart;
run;

data everhaart;
  set everhaart (rename=(col1=severhaart));
  year=(input(substr(_name_, 11), 5.)/12);
  severhaart=severhaart*100;
  drop _name_;
run; 

data sim_cov_cd4;
set main.myresults_hivc;
where int=0;
keep ssqrtcd4:;
run; 

proc transpose data=sim_cov_cd4 out=cd4;
run;

data cd4;
  set cd4 (rename=(col1=ssqrtcd4));
  year=(input(substr(_name_, 9), 5.)/12);
  drop _name_;
run;

data sim_cov_rna;
set main.myresults_hivc;
where int=0;
keep slnrna:;
run; 

proc transpose data=sim_cov_rna out=rna;
run;

data rna;
  set rna (rename=(col1=slnrna));
  year=(input(substr(_name_, 7), 5.)/12);
  drop _name_;
run;

data sim_cov;
merge rna cd4 everhaart visit_cd4 visit_rna obs_cov;
by year;
run; 

options nonumber nodate;
ods pdf file="graph_obs_sim_hivc.pdf" ;
proc sgplot data=surv_new noautolegend;
series x=year y=obs_surv /     lineattrs = (thickness =2 pattern=1);
series x=year y=surv /  lineattrs = (thickness =2 pattern=2);
xaxis label='Time since baseline, years' values = (0 1 2 3 4 5 ) labelattrs=(size=12);
yaxis label='Cumulative risk of AIDS or death (%)'  values = (0 0.5 1 1.5 2.0 2.5 3.0 3.5 4.0 4.5 5.0 ) labelattrs=(size=12); 
run;

proc sgplot data=sim_cov noautolegend;
series x=year y=sqrtcd4 /     lineattrs = (thickness =2 pattern=1);
series x=year y=ssqrtcd4 /   lineattrs = (thickness =2 pattern=2);
xaxis label='Time since baseline, years' values = (0 1 2 3 4 5 ) labelattrs=(size=12);
yaxis label='Mean CD4 count, square root cells/mm3'  values = ( 20 25 30 35 )  labelattrs=(size=12); 
run;

proc sgplot data=sim_cov noautolegend;
series x=year y=lnrna /     lineattrs = (thickness =2 pattern=1);
series x=year y=slnrna / lineattrs = (thickness =2 pattern=2);
xaxis label='Time since baseline, years' values = (0 1 2 3 4 5) labelattrs=(size=12);
yaxis label='Mean HIV-RNA, natural log copies/mL' values = (0  2  4  6 8 10 12) labelattrs=(size=12); 
run;

proc sgplot data=sim_cov noautolegend;
series x=year y=everhaart /      lineattrs = (thickness =2 pattern=1);
series x=year y=severhaart/   lineattrs = (thickness =2 pattern=2);
xaxis label='Time since baseline, years' values = (0 1 2 3 4 5) labelattrs=(size=12);
yaxis label='Proportions who had initiated ART (%)' values = (0 20 40 60 80  100) labelattrs=(size=12); 
run;

proc sgplot data=sim_cov noautolegend;
series x=year y=visit_cd4 /     lineattrs = (thickness =2 pattern=1);
series x=year y=svisit_cd4/   lineattrs = (thickness =2 pattern=2);
xaxis label='Time since baseline, years' values = (0 1 2 3 4 5) labelattrs=(size=12);
yaxis label='Proportions who had CD4 count measured (%)' values = (0 20 40 60 80  100) labelattrs=(size=12); 
run;

proc sgplot data=sim_cov noautolegend;
series x=year y=visit_rna /     lineattrs = (thickness =2 pattern=1);
series x=year y=svisit_rna/   lineattrs = (thickness =2 pattern=2);
xaxis label='Time since baseline, years' values = (0 1 2 3 4 5) labelattrs=(size=12);
yaxis label='Proportions who had HIV-RNA measured (%)' values = (0 20 40 60 80  100) labelattrs=(size=12); 
run;
ods pdf close;

proc datasets library=work kill;
run;
quit;


