
* These three programs use standardization to produce the effect estimates in the subsection
eligibility criteria in section Stage 3;

* STEP I: Save the parameters estimated with the g-formula on  observational dataset including
interaction terms;
 

* STANDARDIZATION INCLUDING INTERACTIONS BETWEEN BASELINE COVS AND ART;

  %include '/proj/sas_macros/gformula/Sept-2016/gformula_3.0.3.sas';

libname main '/proj/START/data/slodi/hivc_start';

options nofmterr nodate   nonumber ls=140  ;



* Second of two consecutive CD4<350;



%macro cutgrace_noaids(intcut=,intgrace=) ;

               
                 
                tgrace = month2 - &intgrace ;
               array dyncond{0:%eval(&timepoints-1)};

					  if ( sqrtcd4 < sqrt(&intcut) AND visit_cd4=1  AND sqrtcd4_l1 < sqrt(&intcut))=1 then do;

                               
                                                dyncond[month2]  = 1;
                                        end;
                                        else do;
                                                dyncond[month2] = 0;
                                        end;
                                       if month2 > 0 and  dyncond[month2 - 1] = 1 then dyncond[month2] = 1;
                                        if dyncond[month2] = 0 and s&&intvar&i [month2] = 1 then do;
                                                &&intvar&i = 0;
                                                s&&intvar&i[month2] = 0 ;
                                                &&intvar&i.._totinterv = &&intvar&i.._totinterv + 1;
                                                intervened = 1;
                                                intervenedk[month2] = 1;
                                                totinterv = totinterv + 1;
                                        end;
                                      
                                        if month2 ge &intgrace then do;
                                                if dyncond[tgrace] = 1 and s&&intvar&i[ month2] = 0 then do;
                                                        &&intvar&i = 1;
                                                        s&&intvar&i[month2] = 1 ;
                                                        &&intvar&i.._totinterv = &&intvar&i.._totinterv + 1;
                                                        intervened = 1;
                                                        intervenedk[month2] = 1;
                                                        totinterv = totinterv + 1;
                                                end;


                                        end;


%mend;



%macro my2mograce;

   if month2 = 2 then do;
        if everhaart = 0 then do;
            everhaart = 1 ;
            severhaart[month2] = 1;
            intervened = 1 ;
            everhaart_totinterv =everhaart_totinterv + 1;
            totinterv = totinterv + 1;
        end;
    end;

%mend;

data cero;
set mylib.cero_hivc_aids_death_3;
where year_0>=2005 and month2<60;
 if _n_=1 then Pi=constant('pi');
		  retain Pi;
country_cat=0; cd4_0_new_cat=0; age_0_new_cat=0; rna_0_new_cat=0;
if country_new=1 or country_new=2 or country_new=6 then country_cat=1;
if cd4_0>650 then cd4_0_new_cat=1; 	
if age_0>35 then age_0_new_cat=1; 
if rna_0>5000 then rna_0_new_cat=1; 		
	mytime = (month2 * (0.001 ** (month2)))*10000 ;
	cos1radiant = cos (0.5*Pi*month2); 
	cos2radiant = cos (2*0.5*Pi*month2); 
	run;


%macro createmytime ;
   mytime = (month2 * (0.001 ** (month2)))*10000; 
	cos1radiant =  cos (0.5*3.14159265359*month2);
	cos2radiant =  cos (2*0.5*3.14159265359*month2);
%mend ;


%let nsamples = 200;

%let interv1 =
intno=1,           intlabel='start within 2 months of baseline', nintvar=1,
intvar1=everhaart, inttype1=-1,  
	inttimes1= 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30
          31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 
		, intusermacro1=my2mograce;


%let interv2 =
intno=2,           intlabel='start within 2 months of second cd4<350', nintvar=1,
intvar1=everhaart, inttype1=-1,  
	inttimes1= 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30
          31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59
		 , intusermacro1=cutgrace_noaids(intcut=351,intgrace=2);


%let timenow=%sysfunc(time(), time.);
%let datenow=%sysfunc(date(), date9.);
%put Initiating Program;
%put Time is &datenow / &timenow ;
%put Outcome: AIDS or death - 2 month intervals;
%put ; 

 
%gformula(
data=cero,
id=id,
time=month2,  timeptype=conspl, timeknots=  3 8 19 34 53,       timepoints=60,
timefuncgen = createmytime ,
outc=event, 
outctype=binsurv, 
outcinteract= b1*3 b2*3 b3*3 b4*3, 
censlost=censor,  
numint=2,
fixedcov=   sex  cd4_0_new_cat    rna_0_new_cat  age_0_new_cat, 
ncov=3, 
cov1=lnrna,     cov1otype=4, cov1ptype=lag1bin, 
cov1randomvisitp = visit_rna, cov1visitpmaxgap = 12 , cov1visitpcount = ts_rna_l1 , cov1addvars =  cos1radiant cos2radiant  ,

cov2=sqrtcd4,     cov2otype=3, cov2ptype=lag1bin, 
cov2randomvisitp = visit_cd4,   cov2visitpcount = ts_cd4_l1 , cov2visitpmaxgap = 12, cov2addvars = cos1radiant cos2radiant , 

cov3=everhaart, cov3otype=2, cov3ptype=tsswitch1, cov3addvars = mytime , 
refint=1,
print_stats=0,
intervname=interv,
 savelib=work,
simuldata=,
rungraphs = 1,
graphfile=hivc_3_stand_inter.pdf, 
runnc = 1 ,
betadata=main.beta_inter,
seed=3,
nsamples=&nsamples,
minimalistic = no ,
usespline = 0 ,
printlogstats = 0
);
