
* These three programs use standardization to produce the effect estimates in the subsection
eligibility criteria in section Stage 3;
* STEP II: simulate on the IMMEDIATE initiation group using the parameters estimated on the observational data in STEP I;

/**********************************************************************************************************/
/***************************************Separate analysis for early and late treatment arm*****************/
/**********************************************************************************************************/
  %include '/proj/sas_macros/gformula/Sept-2016/gformula_3.0.3.sas';
options nofmterr nodate notes nonumber ls=140  ;

libname main '/proj/START/data/slodi/hivc_start';


%macro my2mograce;

   if month2 = 2 then do;
                if everhaart = 0 then do;
        everhaart = 1 ;
        intervened = 1 ;
        everhaart_totinterv = everhaart - intervened + 1;
        totinterv = totinterv + 1;
        severhaart[month2] = 1 ;
        end;
    end;
	
%mend;

%macro createmytime ;
   mytime = (month2 * (0.001 ** (month2)))*10000; 
	cos1radiant =  cos (0.5*3.14159265359*month2);
	cos2radiant =  cos (2*0.5*3.14159265359*month2);
%mend ;


/* %macro smytime ;
   smytime&i 
%mend ;

%macro scosradiant ;
 scos1radiant&i scos2radiant&i
%mend ; */

%let nsamples =200 ;


***********************************************
**** EARLY GROUP
***********************************************;
 data cero_early;
		  set mylib.cero_start_aids_death;
		  where rtreat=1 and id not in (125,511,732,1679,1874,2296,3564,4122,4655) and month2<60  and month2<60 and  ((country_new in (1,2,6) or substr(country_name,1,3)="Bra" )) ;
		  if _n_=1 then Pi=constant('pi');
		  retain Pi;
country_cat=0; cd4_0_new_cat=0; age_0_new_cat=0; rna_0_new_cat=0;
if country_new=1 or country_new=2 or country_new=6 then country_cat=1;
if cd4_0>650 then cd4_0_new_cat=1; 	
if age_0>35 then age_0_new_cat=1; 
if rna_0>5000 then rna_0_new_cat=1; 		
	mytime = (month2 * (0.001 ** (month2)))*10000 ;
	cos1radiant = cos (0.5*Pi*month2); 
	cos2radiant = cos (2*0.5*Pi*month2); 
*	if month2=cutmonth then censor=1; * censor follow-up at administrative end of follow-up;
	run;


%let interv1 =
intno=1,           intlabel='start within 2 months of randomization', nintvar=1,
intvar1=everhaart, inttype1=-1,  
	inttimes1= 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30
          31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 , intusermacro1=my2mograce;
	
%gformula(
data=cero_early,
nsimul=100000, 
id=id,
time=month2,           
timeptype = conspl ,
timeknots=  3 8 19 34 53, 
timepoints=60,
timefuncgen = createmytime ,
outc=event,
outcinteract= b1*3 b2*3 b3*3 b4*3, 
censlost=censor,  
numint=  1  ,
fixedcov=   sex  cd4_0_new_cat  /* country_cat */  rna_0_new_cat  age_0_new_cat,
ncov=3,
cov1=lnrna, cov1otype=4, cov1ptype=lag1bin,   
cov1randomvisitp = visit_rna, cov1visitpmaxgap = 12 , cov1visitpcount = ts_rna_l1 , cov1addvars =  cos1radiant cos2radiant  ,
cov2=sqrtcd4,     cov2otype=3, cov2ptype=lag1bin,  
cov2randomvisitp = visit_cd4,  cov2visitpcount = ts_cd4_l1  ,cov2visitpmaxgap = 12,   cov2addvars = cos1radiant cos2radiant , 
cov3=everhaart, cov3otype=2, cov3ptype=tsswitch1, cov3addvars = mytime , 
refint=1, 
print_stats=0,
intervname=interv,
savelib=main,
rungraphs = 0,
seed=1,
 usebetadata=1,
betadata=main.beta_inter, 
nsamples=&nsamples,
minimalistic = no ,
usespline = 0 ,
printlogstats = 0 
);

